package xyz.tbvns.Objects;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import xyz.tbvns.Decoder;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Slf4j
@Data
public class Object {
    private HashMap<String, String> properties = new HashMap<>();

    public static List<Object> fromLevel(Level level) throws IOException {
        String data = Decoder.decodeLevel(level.getEncodedLevelString());
        String[] usableData = data.split(";");
        List<Object> objects = new ArrayList<>();

        for (int i = 1; i < usableData.length; i++) { //<- 1 here to prevent the first thingy that is not an object
            String object = usableData[i];
            String[] usableObject = object.split(",");
            if (usableObject.length % 2 != 0) {
                log.error("Detected a broken object:\n{}", object);
                continue;
            }
            Object obj = new Object();
            for (int j = 0; j < usableObject.length; j+=2) {
                obj.properties.put(usableObject[j], usableObject[j+1]);
            }
            objects.add(obj);
        }
        return objects;
    }
}
